<?

include ('dynCalendarDate.php');
include ('dynCalendarGroup.php');
include ('dynCalendarSpan.php');

class dynCalendar {
  var $spans = array();
  var $groups = array();
  var $defaultSpansAdditionalParameters = array();

  ////////////////////////////////////////////////////////////////////////////
  // Returns a string containing options of years for a select
  function getYearsOptions($nbYearsAroundCurrent) {
    $res = '';

    // Get n years around current year...
    $date = getdate();
    for ($i = 0 ; $i < $nbYearsAroundCurrent * 2 + 1; $i++) {
      $year = $date['year'] + $nbYearsAroundCurrent - $i;
      $res .= "<option value=\"$year\">$year</option>";
    }    
    
    return $res;
  }

  ////////////////////////////////////////////////////////////////////////////
  // Returns a string containing options of years for a select
  function getGroupsOptions($nbYearsAroundCurrent) {
    $res = '';

    // Get n years around current year...
    $i = 0;
    foreach ($this->groups as $group) {
      $res .= "<option value=\"$i\"" . ($i == 0 ? ' selected' : '') . "><span style=\"color: $group->color;\">$group->name</span></option>";
      $i++;
    }
    
    return $res;
  }

  ////////////////////////////////////////////////////////////////////////////
  // Add a group to contained list
  function addGroup($group) {
    $this->groups[] = $group;
  }

  ////////////////////////////////////////////////////////////////////////////
  // Add a time span
  function addSpan($span) {
    $this->spans[] = $span;
  }

  ////////////////////////////////////////////////////////////////////////////
  // Copy spans and groups to a javascript dynCalendar object
  function copyToJSVar($var) {
    $res = '';
    
    foreach ($this->groups as $group) {
      $res .= "$var.addGroup(new dynCalendarGroup('{$group->name}', '{$group->color}'));\n";
    }
    
    foreach ($this->spans as $span) {
      $res .= "$var.putSpan(new dynCalendarSpan({$span->id}, {$span->group}, new Date({$span->start->year}, {$span->start->month}, {$span->start->day}), new Date({$span->end->year}, {$span->end->month}, {$span->end->day}), {$span->period}, '{$span->comments}'));\n";
    }

    $res .= "$var.reset();\n";

    return $res;
  }

  ////////////////////////////////////////////////////////////////////////////
  // Make a mysql list of queries with given arrays
  function buildMySQLQueries($table, $addedSpans, $modifiedSpans, $removedSpans) {
    $res = array();
    $tmpSpan = new dynCalendarSpan(0, 0, new dynCalendarDate(1970, 0, 1), new dynCalendarDate(1970, 0, 1), 0, '', $this->defaultSpansAdditionalParameters);
    
    if (is_array($addedSpans)) {
      foreach ($addedSpans as $span) {      
        $tmpSpan->loadFromString($span);      
        $res[] = $tmpSpan->getMySQLInsert($table);
      }
    }

    if (is_array($modifiedSpans)) {
      foreach ($modifiedSpans as $span) {
        $tmpSpan->loadFromString($span);
        $res[] = $tmpSpan->getMySQLUpdate($table);
      }
    }

    if (is_array($removedSpans)) {
      foreach ($removedSpans as $span) {
        $tmpSpan->id = (int)$span;
        $res[] = $tmpSpan->getMySQLDelete($table);
      }
    }

    return $res;
  }
};

?>
